# Nom du programme
NAME ?= arithmetique
# Chemin de recherche des fichiers d'en-tête et de library
HEADERDIR := ../include
LIBDIR := ../lib
VPATH = $(HEADERDIR):$(LIBDIR)
# Chemin de sortie du binaire
BINDIR := ../bin
#Définition du compilateur à utiliser
CC ?= gcc

# Options pour la compilation et l'édition des liens
#	Voir 6.7 de la documentation officielle de GNU make
#	pour le mot clef 'override'
override CPPFLAGS += -I$(HEADERDIR)
override CFLAGS += -Wall

# Liste de fichiers objets nécessaires à la bibliothèque
OBJS = main.o
# Chemin complet avec le nom du fichier binaire de sortie
OUT = $(BINDIR)/$(NAME)

###########
# TARGETS #
###########
# Forcer la construction de all et clean
.PHONY: all clean
# all est le premier target, donc celui par défaut
all: $(OUT)

# Création du répertoire de sortie du binaire
$(BINDIR):
	-mkdir -p $@
# Dépendances aux fichiers d'en-têtes
$(OBJS): fonctions.h
# Règle de compilation et édition des liens avec la bibliothèque
$(OUT): $(OBJS) -larithmetique_library | $(BINDIR)
	$(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $^

# Nettoyage
clean:
	-rm -rf $(OUT) $(OBJS)
